Public Class Form1
    Private Sub btnPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPreview.Click
        Me.PrintPreviewDialog1.ClientSize = New Size(500, 600)
        Me.PrintPreviewDialog1.Show()
    End Sub

    Private Sub PrintDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage
        ' Some bogus data.
        Dim headers() As String = {"Fruit", "Vegetable", "Price"}
        Dim values() As Object = { _
            New Object() {"Apple", "Artichoke", 12.45}, _
            New Object() {"Banana", "Bean", 19.95}, _
            New Object() {"Cherry", "Corn", 1.23}, _
            New Object() {"Date", "Donut", 0.45}, _
            New Object() {"Egg", "Eclair", 19.95}, _
            New Object() {"Fig", "Fruit cup", 1.23} _
        }

        ' See how wide the columns need to be.
        Dim num_rows As Integer = values.Length
        Dim num_cols As Integer = values(0).Length

        Dim col_wid(num_cols - 1) As Integer
        Dim header_font As New Font("Times New Roman", 18, FontStyle.Bold)
        CheckColWidths(col_wid, e.Graphics, header_font, headers)

        Dim value_font As New Font("Times New Roman", 16)
        For Each row() As Object In values
            CheckColWidths(col_wid, e.Graphics, value_font, row)
        Next row

        For i As Integer = 0 To num_cols - 1
            col_wid(i) += 20
        Next i

        ' Define column alignments.
        Dim alignments(num_cols - 1) As StringAlignment
        For i As Integer = 0 To num_cols - 1
            If TypeOf values(0)(i) Is Integer Or _
               TypeOf values(0)(i) Is Single Or _
               TypeOf values(0)(i) Is Double _
            Then
                alignments(i) = StringAlignment.Far
            Else
                alignments(i) = StringAlignment.Near
            End If
        Next i

        Const HEADER_MARGIN As Integer = 5
        Const COL_MARGIN As Integer = 5
        Const ROW_HGT As Integer = 30

        ' Get the total width.
        Dim grid_wid As Integer = 0
        For i As Integer = 0 To num_cols - 1
            grid_wid += col_wid(i) + 2 * COL_MARGIN
        Next i

        ' Print the headers.
        Dim x As Integer = e.MarginBounds.Left
        Dim y As Integer = e.MarginBounds.Top

        ' Fill the header's background.
        Dim bg_rect As New Rectangle( _
            x, y, grid_wid, ROW_HGT + HEADER_MARGIN)
        e.Graphics.FillRectangle(Brushes.Black, bg_rect)

        ' Draw the header text.
        For i As Integer = 0 To headers.Length - 1
            Dim layout_rect As New _
                RectangleF(x + COL_MARGIN, y, col_wid(i), ROW_HGT)
            Dim string_format As New StringFormat
            string_format.Alignment = alignments(i)
            string_format.LineAlignment = StringAlignment.Near
            e.Graphics.DrawString(headers(i), _
                header_font, Brushes.White, _
                layout_rect, string_format)
            x += col_wid(i) + 2 * COL_MARGIN
        Next i
        bg_rect.Height -= HEADER_MARGIN
        y += HEADER_MARGIN

        ' Print the values.
        Dim max_x As Integer = x
        For r As Integer = 0 To num_rows - 1
            x = e.MarginBounds.Left
            y += ROW_HGT

            ' Fill the row's background.
            bg_rect.Y = y
            If r Mod 2 = 0 Then
                e.Graphics.FillRectangle(Brushes.LightGray, bg_rect)
            Else
                e.Graphics.FillRectangle(Brushes.Gray, bg_rect)
            End If

            For i As Integer = 0 To num_cols - 1
                ' Draw the text.
                Dim layout_rect As New _
                    RectangleF(x + COL_MARGIN, y, col_wid(i), ROW_HGT)
                Dim string_format As New StringFormat
                string_format.Alignment = alignments(i)
                string_format.LineAlignment = StringAlignment.Near
                e.Graphics.DrawString(values(r)(i), _
                    value_font, Brushes.Black, _
                    layout_rect, string_format)

                x += col_wid(i) + 2 * COL_MARGIN
            Next i
            e.Graphics.DrawLine(Pens.Black, _
                e.MarginBounds.X, y, max_x, y)
        Next r

        ' Draw grid lines.
        Dim grid_hgt As Integer = (values.Length + 1) * ROW_HGT + HEADER_MARGIN
        e.Graphics.DrawRectangle(Pens.Black, _
            e.MarginBounds.X, e.MarginBounds.Y, _
            max_x - e.MarginBounds.X, grid_hgt)
    End Sub

    Private Sub CheckColWidths(ByVal col_wid() As Integer, ByVal gr As Graphics, ByVal the_font As Font, ByVal values() As Object)
        For i As Integer = 0 To values.Length - 1
            Dim txt_size As SizeF = _
                gr.MeasureString( _
                    values(i), the_font)
            If col_wid(i) < txt_size.Width Then
                col_wid(i) = txt_size.Width
            End If
        Next i
    End Sub
End Class
